﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.5
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Public ie_eval As Eval
	Public is_access As Accessibility
	Public gs_status As String
	
	Public is_salesvoucherseries As String = "TXSALSCR"
	Public is_salesvoucherversion As String
	Public is_voucherseries As String = "TXSALMOB"
	Public is_vouchernumber As String
	Public is_voucherversion As String
	Public is_prefix As String
	Public is_suffix As String
	
	Private btn_closecounter As Button
	Private btn_counterclose As Button
	Private btn_ok As Button
	Private btn_save As Button
	Private ibtn_delete As Button
	Private if_flexgrid As FlexGrid
	Private ilbl_back As Label
	Private ilbl_clickbranchname As Label
	Private ilbl_counter As Label
	Private ilbl_counterlist As Label
	Private ilbl_date As Label
	Private ilbl_editdate As Label
	Private ilbl_edittotalmeter As Label
	Private ilbl_edittotalpiece As Label
	Private ilbl_edittotalquantity As Label
	Private ilbl_editvouchernumber As Label
	Private ilbl_lastmeter As Label
	Private ilbl_meter As Label
	Private ilbl_piece As Label
	Private ilbl_pieceormeter As Label
	Private ilbl_titlebarcode As Label
	Private ilbl_totalmeter As Label
	Private ilbl_totalpiece As Label
	Private ilbl_totalquantity As Label
	Private ilbl_vocno As Label
	Private ip_barcodeentrypanel As Panel
	Private ip_barcodevaluepanel As Panel
	Private ip_bookdetailspanel As Panel
	Private ip_counterlabel As Label
	Private ip_counterlistpanel As Panel
	Private ip_counterpanel As Panel
	Private ip_datepanel As Panel
	Private ip_editbarcodeentry As EditText
	Private ip_editmeter As EditText
	Private ip_editpiece As EditText
	Private ip_fulltitlepanel As Panel
	Private ip_lastmeterpanel As Panel
	Private ip_listcounterlabel As Label
	Private ip_meterpanel As Panel
	Private ip_piecepanel As Panel
	Private ip_secondarypanel As Panel
	Private ip_titlelabel As Label
	Private ip_toppanel As Panel
	Private ip_totalmeterpanel As Panel
	Private ip_totalpiecepanel As Panel
	Private ip_totalquantitypanel As Panel
	Private ip_vouchernumberpanel As Panel
	Private ipnl_totalcounter As Panel
	Private is_spnrlastmeter As Spinner
	Private it_counterlistlist As B4XTable
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("scrollviewsalesscreen")
	
	ip_counterlistpanel.Visible = False
	ipnl_totalcounter.Visible = False
	
	Flexgrid_Table
	
End Sub

Private Sub B4XPage_Appear
	'This is called each time this page appears. We need to 
	'check to see if the add button was pressed or the table row was clicked
	'and act accordingly

	Dim bl As billing_list = B4XPages.GetPage ("billing_list")
	
	If bl.gs_status = "U" Then
		ShowFlexgridTable
	Else 
		ibtn_delete.Visible = False
	End If
	
End Sub

Sub Flexgrid_Table
	
	ie_eval.Initialize(if_flexgrid)
	
	if_flexgrid.Font = xui.CreateFont(Typeface.DEFAULT, 14/is_access.GetUserFontScale)
	if_flexgrid.HeaderFont = xui.CreateFont(Typeface.DEFAULT, 15/is_access.GetUserFontScale)

	if_flexgrid.ColsName = Array As String("Mobile Sales Item Temp Pk", "S.No.","Seq.No", "Barcode", "Variety Name", "Varietyfk", _
										   "Unit", "Barcode Item", "BarcodeSingleBulk", "Company Code", "Piece", _
										   "Last Meter", "Meter","Total Qty.", "Row Status", "Piece/Meter")

	if_flexgrid.ColsWidth = Array As Int(0dip, 75dip, 0dip,120dip,170dip,0dip, _
									     0dip,0dip,0dip,0dip,75dip, _
									     100dip,75dip,100dip, 0dip, 0dip)

	if_flexgrid.ColsType = Array As Int(if_flexgrid.TypeString,if_flexgrid.TypeString, if_flexgrid.TypeString, if_flexgrid.TypeString,if_flexgrid.TypeString,if_flexgrid.TypeString, _
									    if_flexgrid.TypeString,if_flexgrid.TypeString,if_flexgrid.TypeString,if_flexgrid.TypeString,if_flexgrid.TypeString, _
									    if_flexgrid.TypeString,if_flexgrid.TypeFloat,if_flexgrid.TypeFloat, if_flexgrid.TypeString, if_flexgrid.TypeString)
									 
	if_flexgrid.ColsAlignment = Array As String("LEFT","CENTER","CENTER","CENTER","CENTER","CENTER", _
											    "CENTER","CENTER","CENTER","RIGHT","RIGHT", _
											    "CENTER","RIGHT","RIGHT","CENTER","CENTER")
	
End Sub

Sub ShowFlexgridTable
	
	if_flexgrid.ClearRows
	
	Dim ls_serialnumber As Int = 0
		
	Dim s As String = File.ReadString(File.DirAssets, "textiledetail.json")
		
	Dim parser As JSONParser
	parser.Initialize(s)
		
	Dim Data As List = parser.NextArray
	
	Dim coldata As Map
	coldata.Initialize
	
	coldata = Data.Get(0)
			
	Dim ls_mobilesalesitemtemppk, ls_barcode, ls_varietyfk, ls_varietyname As String
	Dim ls_unit, ls_barcodeitem, ls_barcodesinglebulk, ls_companycode As String
	Dim ls_voucherdate, ls_piece, ls_meter, ls_totalquantity, ls_vouchernumber As String
	Dim ls_voucherseries, ls_sequencenumber, ls_lastmeter As String, ls_piecemeter As String
				
	ls_serialnumber = ls_serialnumber + 1
			
	ls_mobilesalesitemtemppk = coldata.Get("mobilesalesitemtemppk")
	ls_barcode = coldata.Get("barcode")
	ls_varietyname = coldata.Get("varietyname")
	ls_varietyfk = coldata.Get("varietyfk")
	ls_unit = coldata.Get("unit")
	ls_barcodeitem = coldata.Get("barcodeitem")
	ls_barcodesinglebulk = coldata.Get("barcodesinglebulk")
	ls_companycode = coldata.Get("companycode")
	is_prefix = coldata.Get("prefix")
	is_suffix = coldata.Get("suffix")
	ls_voucherdate = coldata.Get("voucherdate")
	ls_piece = coldata.Get("piece")
	ls_meter = coldata.Get("meter")
	ls_totalquantity = coldata.Get("totalquantity")
	ls_voucherseries = coldata.Get("voucherseries")
	is_voucherversion = coldata.Get("voucherversion")
	is_vouchernumber = coldata.Get("vouchernumber")
	ls_sequencenumber = coldata.Get("sequencenumber")
	ls_lastmeter = coldata.Get("lastmeter")
		
	is_salesvoucherseries = coldata.Get("salesvoucherseries")
	is_salesvoucherversion = coldata.Get("salesvoucherversion")
		
			
	If ls_unit = "N" Then
		If ls_barcodesinglebulk = "S" Then
			ls_piecemeter = "Nos"
		Else If ls_barcodesinglebulk = "B" Then
			ls_piecemeter = "Bulk"
		Else
			ls_piecemeter = "Meter"
		End If
	End If
					
	If ls_lastmeter = "N" Then
		ls_lastmeter = "No"
	Else If ls_lastmeter = "Y" Then
		ls_lastmeter = "Yes"
	End If
			
	If is_prefix = "null" Then
		is_prefix = ""
	End If
	
	If is_suffix = "null" Then
		is_suffix = ""
	End If
			
	Dim l As Long
	DateTime.DateFormat = "yyyy-mm-dd"
	Dim datestring As String = ls_voucherdate
	l = DateTime.DateParse(datestring)
	DateTime.DateFormat = "dd-mm-yyyy"
	ls_voucherdate = DateTime.Date(l)
							
	ls_vouchernumber = is_prefix & is_vouchernumber & is_suffix
														
	Dim lo_row(16) As Object
			
	lo_row(0) = ls_mobilesalesitemtemppk
	lo_row(1) = ls_sequencenumber
	lo_row(2) = ls_sequencenumber
	lo_row(3) = ls_barcode
	lo_row(4) = ls_varietyname
	lo_row(5) = ls_varietyfk
	lo_row(6) = ls_unit
	lo_row(7) = ls_barcodeitem
	lo_row(8) = ls_barcodesinglebulk
	lo_row(9) = ls_companycode
	lo_row(10) = ls_piece
	lo_row(11) = ls_lastmeter
	lo_row(12) = ls_meter
	lo_row(13) = ls_totalquantity
	lo_row(14) = "TM"
	lo_row(15) = ls_piecemeter

	if_flexgrid.AddRow(lo_row, False)

	Sleep(1)

	if_flexgrid.SetColAlignment(0,"LEFT")
			
		
	ilbl_editvouchernumber.Text = ls_vouchernumber
	ilbl_editdate.Text = ls_voucherdate

	
End Sub

Private Sub B4XPage_CloseRequest As ResumableSub
	Dim sf As Object = xui.Msgbox2Async("Do You Want To Close?", "Attention", "Yes", "", "No", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		B4XPages.ShowPage("billing_list")
		Return True
	Else
		Return False
	End If
End Sub